﻿package {
	
	import flash.geom.Point;
	
	public class Particle {
		
		private static const X_LIMIT:Number = 30;
		private static const Y_LIMIT:Number = 30;
		private static const FRICTION:Number = 0.97;
		
		private var _force:Point;
		private var _x:Number;
		private var _y:Number;
		private var _prevx:Number;
		private var _prevy:Number;
		
		public function Particle(x:Number, y:Number) {
			_force = new Point();
			_x = x;
			_y = y;
		}
		
		public function addForce(xForce:Number, yForce:Number):void {
			_force.x += xForce;
			_force.x = Math.max(-X_LIMIT, Math.min(X_LIMIT, _force.x));
			
			_force.y += yForce;
			_force.y = Math.max(-Y_LIMIT, Math.min(Y_LIMIT, _force.y));
			
			_force.x *= FRICTION;
			_force.y *= FRICTION;
		}
		
		public function applyForce():void {
			_prevx = _x;
			_prevy = _y;
			_x += _force.x;
			_y += _force.y;
		}
		
		public function get force():Point { return _force; }
		public function get x():Number { return _x; }
		public function get y():Number { return _y; }
		public function get prevx():Number { return _prevx; }
		public function get prevy():Number { return _prevy; }
		
	}
	
}